diff debian/postinst @ 301:3b5b7f3fd71f noffle

[svn] initial debian/ upload
author godisch
date Fri, 14 Feb 2003 13:54:32 +0000
parents
children 5ec39beae9c5
line wrap: on
line diff
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/debian/postinst	Fri Feb 14 13:54:32 2003 +0000
@@ -0,0 +1,114 @@
+#!/bin/sh
+# $Id: postinst 434 2003-02-14 13:54:32Z godisch $
+
+set -e
+. /usr/share/debconf/confmodule
+db_version 2.0
+
+server_config=/etc/news/noffle.conf
+debian_config=/etc/default/noffle
+
+maxfetch_default=300
+defexpire_default=14
+
+case "$1" in
+configure)
+	if dpkg --compare-versions "$2" lt-nl 1.1.2-1; then
+		echo ""
+		echo "/etc/noffle/conf moved to $server_config, /etc/noffle/conf.debian"
+		echo "moved to $debian_config. /etc/noffle and /var/log/noffle are not"
+		echo "used any longer, you may remove them. noffle expiration logs are"
+		echo "still available through syslog."
+		echo ""
+		sleep 2
+		mv -f /etc/noffle/conf $server_config || :
+		mv -f /etc/noffle/conf.debian $debian_config || :
+		mv -f /etc/noffle/conf.old $server_config.old 2> /dev/null || :
+		mv -f /etc/noffle/conf.debian.old $debian_config.old 2> /dev/null || :
+		rmdir /etc/noffle || :
+	fi
+	if dpkg --compare-versions "$2" eq 1.1.2-1; then
+		# 1.1.2-1 was in unstable only, don't notify
+		mv -f /etc/noffle.conf $server_config || :
+		mv -f /etc/noffle.conf.old $server_config.old 2> /dev/null || :
+	fi
+	# if we are allowed to overwrite $server_config and $debian_config...
+	db_get noffle/debconf || RET=""
+	if [ "$RET" != false ]; then
+		db_get noffle/port || RET=""
+		port="$RET"
+		[ -z "$port" -o "$port" = 119 ] && port=nntp
+		# maybe disabled only, e.g. dpkg -r noffle
+		update-inetd --remove "/usr/bin/noffle -r" || :
+		update-inetd --group MAIL --add "$port\tstream\ttcp\tnowait\tnews\t/usr/sbin/tcpd /usr/bin/noffle -r"
+		db_get noffle/server || RET=""
+		server="$RET"
+		[ "$server" ] || server=news
+		db_get noffle/username || RET=""
+		username="$RET"
+		db_get noffle/password || RET=""
+		password="$RET"
+		db_get noffle/fetchmode || RET=""
+		fetchmode="$RET"
+		[ "$fetchmode" ] || if [ -x /usr/sbin/pppd ]; then
+			fetchmode=ppp
+		else
+			fetchmode=cron
+		fi
+		db_get noffle/maxfetch || RET=""
+		maxfetch="$RET"
+		[ "$maxfetch" ] || maxfetch="$maxfetch_default"
+		db_get noffle/default-expire || RET=""
+		defexpire="$RET"
+		[ "$defexpire" ] || defexpire="$defexpire_default"
+		# try to be idempotent
+		if [ ! -e $server_config.new -a ! -e $debian_config.new ]; then
+			# make some backup files
+			cmp -s $server_config $server_config.old || \
+				cp -pf $server_config $server_config.old 2> /dev/null || :
+			cmp -s $debian_config $debian_config.old || \
+				cp -pf $debian_config $debian_config.old 2> /dev/null || :
+		fi
+		# $server_config may contain sensitive information for NNTP authentication
+		umask 027
+		# we need to use sed instead of Perl to avoid another package dependency
+		cat /usr/share/noffle/noffle.conf | \
+			sed "s/^server[[:space:]].*/server $server $username $password/" | \
+			sed "s/^max-fetch[[:space:]].*/max-fetch $maxfetch/" | \
+			sed "s/^default-expire[[:space:]].*/default-expire $defexpire/" \
+			> $server_config.new
+		chgrp news $server_config.new
+		umask 022
+		cat /usr/share/noffle/conf.debian | \
+			sed "s/^NOFFLE_FETCHMODE=.*/NOFFLE_FETCHMODE=$fetchmode/" \
+			> $debian_config.new
+		mv -f $server_config.new $server_config
+		mv -f $debian_config.new $debian_config
+	fi
+	# sanity checks
+	chown -R news:news /var/lock/noffle /var/spool/noffle
+	chmod -R go-w /var/lock/noffle /var/spool/noffle
+	find /var/lock/noffle /var/spool/noffle -type d -print0 | xargs -0 chmod g+s
+	if [ -z "$2" ]; then
+		echo ""
+		echo "You need to query your parent NNTP server manually for a group overview"
+		echo "and descriptions. Have a look at /usr/share/doc/noffle/README.Debian for"
+		echo "information how to do this."
+		echo ""
+		sleep 2
+	fi
+	;;
+abort-upgrade|abort-remove|abort-deconfigure)
+	;;
+*)
+	echo "postinst called with unknown argument '$1'" >&2
+	exit 1
+	;;
+esac
+
+if [ -x /etc/init.d/noffle ]; then
+	update-rc.d noffle defaults > /dev/null
+	invoke-rc.d noffle start || :
+fi
+
+exit 0